import es
import gamethread
import cPickle
import esamlib
import threading
import time


#This addon ONLY supports bans by STEAMID!

info = es.AddonInfo()
info.name = "bansaver"
info.author = "Brainsucker"
info.description = "Saves NON-Permanent bans. So the bans will not expire at a server restart."
info.url = "http://addons.eventscripts.com/addons/view/bansaver"
info.version = "1.1"


def updatecheck():
	a = esamlib.getAddon(info["name"])
	try:
		newest_ver = a.currentversion
	except:
		es.dbgmsg(0, "[BAN SAVER] Unable to check for updates")
	else:
		if info["version"] != newest_ver:
			es.log("[BAN SAVER] You current Serverversion is out of date. Please check for updates! (%s)" % info["url"])
			
def remove_ban_time():
	gamethread.delayedname(60, "bansaver_loop", remove_ban_time, ())
	bankeys = bandict["steamids"].keys()
	if bandict.has_key("lastloop"):
		if bandict["lastloop"] == time.strftime("%H.%M"):
			return
	if len(bankeys):
		del_key = []
		for k in bankeys:
			if bandict["steamids"][k] > 0:
				bandict["steamids"][k] -= 1
			else:
				del_key.append(k)
		if len(del_key):
			for c in bandict["steamids"]:
				del bandict["steamids"][c]
		bandict["lastloop"] = time.strftime("%H.%M")
		threading.Thread(target=cPickle.dump(bandict, open(addonpath + "/banned_user.db", "wb")))
			
addonpath = es.getAddonPath(info["name"])
bandict = {}
bandict["steamids"] = {}
try:
	bandict = cPickle.load(open(addonpath + "/banned_user.db", "rb"))
except:
	pass
else:
	for b in bandict["steamids"].keys():
		es.server.queuecmd("banid %i %s" % (bandict["steamids"][b], b))

if es.getplayercount() == 0:
	updatecheck()
remove_ban_time()
es.ServerVar(info["name"], info["version"]).makepublic()

def unload():
	gamethread.cancelDelayed("bansaver_loop")

def server_addban(ev):
	steamid = ev["networkid"]
	dur = ev["duration"]
	if dur != "permanently":
		a = dur.split()[1]
		if a.isdigit():
			bantime = int(float(dur.split()[1]))
			if dur > 0:
				bandict["steamids"][steamid] = bantime
	
def server_removeban(ev):
	steamid = ev["networkid"]
	if bandict["steamids"].has_key(steamid):
		del bandict["steamids"][steamid]